program mzcarver;

{$APPTYPE CONSOLE}

uses
  SysUtils, Parsing;

var
  i: Integer;
  WriteFileName, OriginalFileName, Version:string;
  Dump, ReadFile, WriteFile:boolean;

begin
  Dump:=false;
  ReadFile:=false;
  WriteFile:=false;
  Version:='0.1';

  if ParamCount = 0 then
    writeln('Try /h for help');
    
  i:=1;
  while i <= ParamCount do
    begin
      if (lowercase(paramstr(i)) = '/h') or (lowercase(paramstr(i)) = '/help') then
        begin
          writeln(chr(9) + '/h or /help (optional) - provides this menu');
          writeln(chr(9) + '/v or /version (optional) - provides version information and general data about program');
          writeln(chr(9) + '/r or /read (required) - tcp dump file to read in');
          writeln(chr(9) + '/w or /write (optional) - provide the base name to save exported data to, otherwise default will be used');
          writeln(chr(9) + chr(9) + '(original filename + new extension)');
          writeln(chr(9) + '/d or /dump (optional) - will dump out starting and ending data if there was any for later analysis');
          writeln(chr(9) + '');
        end
      else if (lowercase(paramstr(i)) = '/v') or (lowercase(paramstr(i)) = '/version') then
        begin
          writeln(chr(9) + 'Title:  MZ Carver');
          writeln(chr(9) + 'Version:  ' + Version);
          writeln(chr(9) + 'Program by Eric Kollmann');
          writeln(chr(9) + 'Copyright 2010');
          writeln('');
          writeln(chr(9) + 'This program is designed to take a tcp data dump from a pcap trace and search for a PE file within it');
          writeln(chr(9) + '');
        end
      else if (lowercase(paramstr(i)) = '/d') or (lowercase(paramstr(i)) = '/dump') then
        begin
          dump:=true;
        end
      else if (lowercase(paramstr(i)) = '/w') or (lowercase(paramstr(i)) = '/write') then
        begin
          inc(i);
          WriteFileName:=paramstr(i);
          if length(WriteFileName) > 0 then
            begin
              if WriteFileName[1] <> '/' then
                WriteFile:=true;
            end;
          if WriteFile = false then
            writeln('invalid option after /w');
        end
      else if (lowercase(paramstr(i)) = '/r') or (lowercase(paramstr(i)) = '/read') then
        begin
          inc(i);
          OriginalFileName:=paramstr(i);
          if length(OriginalFileName) > 0 then
            begin
              if OriginalFileName[1] <> '/' then
                ReadFile:=true;
            end;
          if ReadFile = false then
            writeln('invalid option after /r');
        end;
      inc(i);
    end;

  if WriteFile=false then
    WriteFileName:=OriginalFileName;

  if ReadFile then
    MZParser(OriginalFileName, WriteFileName, Dump);
end.


